<script lang="ts">
import Vue from 'vue';
import { SolutionsVideoModal, SlpPlayIcon } from '../solutions/index.vue';

export default Vue.extend({
  name: 'DibIntroHighlight',
  components: {
    SolutionsVideoModal,
    SlpPlayIcon,
  },
  props: {
    data: {
      type: Object,
      required: true,
      default: null,
    },
  },
  data() {
    return {
      modal: {
        open: false,
      },
    };
  },
  methods: {
    openModal() {
      this.modal.open = true;
      // Make sure Vimeo analytics work:
      // https://vimeo.zendesk.com/hc/en-us/articles/115002859607-Integrate-the-Vimeo-player-with-Google-Tag-Manager
      setTimeout(() => {
        // eslint-disable-next-line no-underscore-dangle
        window.__vimeoRefresh();
      }, 3000);
    },
    closeModal() {
      this.modal.open = false;
    },
  },
});
</script>

<template>
  <section class="dib-intro-highlight">
    <div class="dib-intro-highlight__intro">
      <SlpContainer class="dib-intro-highlight__container">
        <div>
          <SlpTypography variant="heading4-bold" tag="h2" class="slp-mb-32">{{
            data.header
          }}</SlpTypography>

          <img :src="data.image.src" :alt="data.image.alt" />
        </div>

        <div class="dib-intro-highlight__video">
          <div @click="openModal">
            <img :src="data.video.image" :alt="data.video.title" />
            <div class="dib-intro-highlight__icon">
              <SlpPlayIcon />
            </div>
          </div>
        </div>
      </SlpContainer>
    </div>
    <div class="dib-intro-highlight__copy">
      <SlpContainer>
        <div class="dib-intro-highlight__gradient-header"></div>
        <SlpRow class="dib-intro-highlight__row">
          <SlpColumn :cols="6" class="dib-intro-highlight__col">
            <SlpTypography variant="heading2-bold" tag="h3">{{
              data.copy.header
            }}</SlpTypography>
          </SlpColumn>
          <SlpColumn :cols="6" class="dib-intro-highlight__col">
            <SlpMarkdown :text="data.copy.text" />
          </SlpColumn>
        </SlpRow>
      </SlpContainer>
    </div>
    <SolutionsVideoModal
      v-show="modal.open"
      light-background
      :visible="modal.open"
      @close="closeModal"
    >
      <template #body>
        <iframe
          width="560"
          height="315"
          :src="data.video.src"
          :title="data.video.title ?? 'Video player'"
          frameborder="0"
          allow="accelerometer; autoplay; clipboard-write; encrypted-media; gyroscope; picture-in-picture; web-share"
          allowfullscreen
        ></iframe>
      </template>
    </SolutionsVideoModal>
  </section>
</template>

<style lang="scss" scoped>
.dib-intro-highlight {
  text-align: center;

  position: relative;
  @media (min-width: $breakpoint-lg) {
    margin: 0 0 $spacing-96 0;
  }
  z-index: 0;
  &__container {
    position: relative;
  }
  &__intro {
    position: relative;
    &:before {
      content: '';
      position: absolute;
      width: 100%;
      height: calc(100% - 96px);
      left: 0;
      top: 0;
      background: linear-gradient(180deg, #fff 0%, rgba(255, 255, 255, 0) 100%),
        linear-gradient(
          126deg,
          #eee7fd 0%,
          rgba(246, 243, 254, 0.83) 49.71%,
          rgba(255, 212, 216, 0.45) 100%
        );
    }
  }
  &__video {
    border-radius: 0px 0px 64px 8px;
    overflow: hidden;
    max-width: 640px;
    margin: $spacing-48 auto 0 auto;
    line-height: 0;
    position: relative;
    img {
      width: 100%;
      height: auto;
      object-fit: cover;
    }
  }
  &__icon {
    position: absolute;
    top: 40%;
    right: 45%;
    opacity: 0.75;
    transition: all 0.3s;
    cursor: pointer;
    &:hover {
      opacity: 1;
    }
  }
  &__copy {
    text-align: left;
    padding: $spacing-96 0;
  }
  &__gradient-header {
    background: linear-gradient(90deg, #ffc8c6 0%, #b3bded 100%);
    height: 4px;
    width: 95px;
    border-radius: 10px;
    margin-bottom: $spacing-16;
  }
  &__row {
    margin-left: -32px;
  }
  &__col {
    padding-left: 32px;
  }
}
</style>
